
%global meadversion 3.18.1
%global namedversion 3.18.1.GA-redhat-1
%global meadalpha .GA_redhat_1
%global meadrel .1
%global serial 6
%global namedversionrel redhat-1

%bcond_without mead

%global shortname javassist

%define maven_version 3.18.1.GA-redhat-1

Name:           javassist-eap6
Version:        %{meadversion}
Release:        %{serial}%{meadalpha}%{meadrel}%{?dist}
Epoch:          0
Summary:        Java Programming Assistant: bytecode manipulation
Group:          Development/Java

%if %with mead
Source100: javassist-3.18.1.GA-redhat-1-scm-sources.zip
Source102: javassist-3.18.1.GA-redhat-1.pom
Source103: javassist-3.18.1.GA-redhat-1-project-sources.tar.gz
Source104: javassist-3.18.1.GA-redhat-1.jar
Source105: javassist-3.18.1.GA-redhat-1-sources.jar
%endif

License:        MPLv1.1/LGPLv2.1
URL:            http://www.csg.is.titech.ac.jp/~chiba/javassist/
%if 0%{?rhel} == 6
Obsoletes:      javassist = 0:3.15.0-2.GA_redhat_1.2%{?dist}
Obsoletes:      javassist = 0:3.15.0-5.GA_redhat_2%{?dist}.3
%endif
Requires:       jpackage-utils
BuildRequires:  jpackage-utils
BuildArch:      noarch
BuildRoot:      %{_tmppath}/javassist-%{namedversion}-%{release}-root

%description
Javassist (Java Programming Assistant) makes Java bytecode manipulation 
simple. It is a class library for editing bytecodes in Java; it enables Java 
programs to define a new class at runtime and to modify a class file when the 
JVM loads it. Unlike other similar bytecode editors, Javassist provides two 
levels of API: source level and bytecode level. If the users use the 
source-level API, they can edit a class file without knowledge of the 
specifications of the Java bytecode. The whole API is designed with only the 
vocabulary of the Java language. You can even specify inserted bytecode in the 
form of source text; Javassist compiles it on the fly. On the other hand, the 
bytecode-level API allows the users to directly edit a class file as other 
editors.

%package -n %{shortname}
Summary:        Java Programming Assistant: bytecode manipulation
Group:          Development/Java

Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
BuildRequires:  jpackage-utils

%description -n %{shortname}
Javassist (Java Programming Assistant) makes Java bytecode manipulation
simple. It is a class library for editing bytecodes in Java; it enables Java
programs to define a new class at runtime and to modify a class file when the
JVM loads it. Unlike other similar bytecode editors, Javassist provides two
levels of API: source level and bytecode level. If the users use the
source-level API, they can edit a class file without knowledge of the
specifications of the Java bytecode. The whole API is designed with only the
vocabulary of the Java language. You can even specify inserted bytecode in the
form of source text; Javassist compiles it on the fly. On the other hand, the
bytecode-level API allows the users to directly edit a class file as other
editors.

%prep
%setup -q -n javassist -T -b 100

%build

%install
%{__rm} -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%{__cp} -p %{_sourcedir}/%{shortname}-%{namedversion}.jar %{buildroot}%{_javadir}/%{shortname}-%{namedversion}.jar
%{__cp} -p %{_sourcedir}/%{shortname}-%{namedversion}-sources.jar %{buildroot}%{_javadir}/%{shortname}-%{namedversion}-sources.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done)

# alternate jar location
%{__mkdir_p} %{buildroot}%{_javadir}/%{name}
%{__cp} -p %{_sourcedir}/%{shortname}-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}/%{shortname}-%{namedversion}.jar
%{__cp} -p %{_sourcedir}/%{shortname}-%{namedversion}-sources.jar %{buildroot}%{_javadir}/%{name}/%{shortname}-%{namedversion}-sources.jar
(cd %{buildroot}%{_javadir}/%{name} && for jar in *-%{namedversion}*.jar; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done)

# pom
%{__mkdir_p} %{buildroot}%{_mavenpomdir}
%{__cp} -p %{_sourcedir}/%{shortname}-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-%{shortname}.pom

# depmap
%add_to_maven_depmap org.javassist javassist %{namedversion} JPP %{shortname}

%clean
%{__rm} -rf %{buildroot}

%post -n %{shortname}
%update_maven_depmap

%postun -n %{shortname}
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc License.html Readme.html tutorial/
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/%{shortname}-%{namedversion}.jar
%{_javadir}/%{name}/%{shortname}.jar
%{_javadir}/%{name}/%{shortname}-%{namedversion}-sources.jar
%{_javadir}/%{name}/%{shortname}-sources.jar

%files -n %{shortname}
%defattr(0644,root,root,0755)
%doc License.html Readme.html tutorial/
%{_javadir}/%{shortname}-%{namedversion}.jar
%{_javadir}/%{shortname}.jar
%{_javadir}/%{shortname}-%{namedversion}-sources.jar
%{_javadir}/%{shortname}-sources.jar
%{_mavenpomdir}/JPP-%{shortname}.pom
%{_mavendepmapfragdir}/%{name}

%if %without mead
%files -n %{shortname}-demo
%defattr(0644,root,root,0755)
%{_datadir}/%{shortname}-%{namedversion}

%if %with javadoc
%files -n %{shortname}-javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{shortname}-%{namedversion}
%{_javadocdir}/%{shortname}
%endif

%files -n %{shortname}-manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{shortname}-%{namedversion}
%endif

%if %with repolib
%files -n %{shortname}-repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}/repository.jboss.com
%endif

%changelog
* Wed Nov 26 2014 Lin Gao <lgao@redhat.com> - 3.18.1-6.GA_redhat_1.1
- Rebuild wrapperRPM

* Wed Nov 26 2014 Lin Gao <lgao@redhat.com> - 3.18.1-6.GA_redhat_1.1
- Rebuilding to fix invalid OSGI version

* Mon Oct 20 2014 David Walluck <dwalluck@redhat.com> - 3.18.1-5.GA_redhat_1.1
- fix Requires: jpackage-utils
- add BuildRequires: jpackage-utils
- add dirs to file lists
- add doc
- remove non-mead code

* Mon Oct 20 2014 David Walluck <dwalluck@redhat.com> - 3.18.1-4.GA_redhat_1.1
- fix two dates in changelog

* Mon Oct 20 2014 David Walluck <dwalluck@redhat.com> - 3.18.1-3.GA_redhat_1.1
- fix Obsoletes

* Mon Oct 20 2014 David Walluck <dwalluck@redhat.com> - 3.18.1-2.GA_redhat_1.1
- fix bz#1140576

* Thu Oct 31 2013 Permaine Cheung <pcheung@redhat.com> - 3.18-1.1.GA_redhat_1.1
- Rewrap to get the proper version

* Tue Sep 10 2013 Hui Wang <huwang@redhat.com> - 3.18-1.1_GA_redhat_1.1
- Upgrade to 3.18.1.GA

* Wed Sep 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:3.15.0-5.GA_redhat_2.3
- Rebuild for MD5

* Mon Aug 20 2012 Vladimir Dosoudil <dosoudil@redhat.com> - 0:3.15.0-4.GA_redhat_2.3
- Update poms for eap 6.0.1

* Mon Aug 13 2012 Fernando Nasser <fnasser@redhat.com> - 0:3.15.0-3.GA_redhat_2.3
- Rebuild unsigned

* Fri Aug 10 2012 Fernando Nasser <fnasser@redhat.com> - 0:3.15.0-3.GA_redhat_2.2
- Rebuild unsigned

* Thu Jul 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:3.15.0-3.GA_redhat_1.1
- Rebuild using cache signing

* Mon Jun 18 2012 Martha Benitez <mbenitez@redhat.com> - 0:3.15.0-3.GA_redhat_1
- Build with maven

* Tue Apr 03 2012 Martha Benitez <mbenitez@redhat.com> - 0:3.15.0-2.GA_redhat_1.2
- Rebuild with a -eap6 suffix to avoid conflict with RHEL-6 base
- Update vman.patch

* Mon Mar 26 2012 Fernando Nasser <fnasser@redhat.com> - 0:3.15.0-2.GA_redhat_1.1
- Rebuild using cache signing

* Wed Dec 14 2011 Yong Yang <yyang@redhat.com> - 0:3.15.0-2.GA_redhat_1
- Upgrade to 3.15.0.GA

* Mon Nov 28 2011 Yong Yang <yyang@redhat.com> - 0:3.14.0-1
- Upgrade to 3.14.0.GA

* Wed May 25 2011 Yong Yang <yyang@redhat.com> - 0:3.12.1-1
- Upgrade to 3.12.1

* Wed Jan 19 2011 Hui Wang <huwang@redhat.com> - 0:3.12.0.GA-3
- Use mvn-jpp for deploy
- Rebuild
- Add BRs maven-compiler-plugin, maven-jar-plugin and maven-source-plugin

* Wed Nov 17 2010 Hui Wang <huwang@redhat.com> - 0:3.12.0-2
- Fix %%files for signed jars
- Add upload.sh and content of maven2-brew to repolib

* Fri Jun 4 2010 Yiqiao Wang <yiwang@redhat.com> - 0:3.12.0-1
- Merge from RHEL4 

* Tue Jun 01 2010 Martha Benitez <mbenitez@redhat.com> - 0:3.12.0-1
- Upgrade to 3.12.0.GA
- Add pom.xml to repolib
- Fix tag in component-info.xml

* Mon May 17 2010 Martha Benitez <mbenitez@redhat.com> - 0:3.9.0-3.3.1
- rebuilt

* Wed Apr 21 2010 Weinan Li <weli@redhat.com>  0:3.9.0-3.3
- Rebuild

* Thu Aug 20 2009 Martha Benitez <mbenitez@redhat.com> 0:3.9.0-3.2
- Add reltag to depmap fragments

* Thu May 21 2009 Martha Benitez <mbenitez@redhat.com> 0:3.9.0-3.1
- Change jpackage-utils >= 0:1.7.5 to jpackage-utils >= 0:1.7.3

* Tue Feb 10 2009 David Walluck <dwalluck@redhat.com> 0:3.9.0-3
- add pom

* Thu Jan 15 2009 David Walluck <dwalluck@redhat.com> 0:3.9.0-2
- bump release so that we are newer than f10

* Thu Jan 08 2009 David Walluck <dwalluck@redhat.com> 0:3.9.0-1
- 3.9.0

* Mon Dec 08 2008 Will Tatam <will.tatam@red61.com> 3.8.0-2
- Auto rebuild for JPackage 5 in mock

* Mon Jul 14 2008 Fernando Nasser <fnasser@redhat.com> - 0:3.8.0-1
- Upgrade to 3.8.0

* Mon Jun 2 2008 Permaine Cheung <pcheung@redhat.com> - 0:3.6.0-2
- First JPP5 build

* Tue Oct 2 2007 Clive Saldanha <csaldanh@redhat.com> - 0:3.6.0-1jpp.ep1.2
- Rebuilding with 1.4 

* Tue Oct 2 2007 Clive Saldanha <csaldanh@redhat.com> - 0:3.6.0-1jpp.ep1.1
- Upgrade to 3.6.0.GA 

* Fri May 4 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:3.5.0-1jpp.ep1.5
- Replace 3.5.0-brew with 3.5.0.GA-brew

* Wed May 2 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:3.5.0-1jpp.ep1.4
- Respun with fresh export of rel_3_5_GA tag

* Wed May 2 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:3.5.0-1jpp.ep1.3
- Respun with fresh export of Javassist_3_5_0_GA tag

* Mon Apr 30 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:3.5.0-1jpp.ep1.2
- Fix component-info.xml and specs reference to directory locations in repolib

* Mon Apr 30 2007 Deepak Bhole <dbhole@redhat.com> - 0:3.5.0-1jpp.ep1.1
- Upgrade to 3.5.0 GA

* Tue Mar 13 2007 Fernando Nasser <fnasser@redhat.com> - 0:3.5-0.cr1.2jpp.ep1.1
- Rebuild

* Thu Mar 1 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:3.5-0.cr1.2jpp.el4ep1.4
- Add src jar to lib directory and component-info.xml

* Tue Feb 20 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:3.5-0.cr1.2jpp.el4ep1.3
- Add -brew suffix

* Sat Feb 17 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:3.5-0.cr1.2jpp.el4ep1.2
- Add repolib support

* Sat Feb 17 2007 Fernando Nasser <fnasser@redhat.com> - 0:3.5-0.cr1.2jpp.el4ep1.1
- Merge with upstream for upgrade

* Sat Feb 17 2007 Fernando Nasser <fnasser@redhat.com> - 0:3.5-0.cr1.2jpp
- Remove vendor and distribution tags
- Remove tabs

* Sat Feb 17 2007 Fernando Nasser <fnasser@redhat.com> - 0:3.5-0.cr1.1jpp
- Upgrade to 3.5.CR1

* Tue Aug 01 2006 Fernando Nasser <fnasser@redhat.com> - 0:3.2-0.cr2.1jpp_1rh
- Merge with upstream

* Tue Jun 13 2006 Ralph Apel <r.apel@r-apel.de> - 0:3.2-0.cr2.1jpp
- Upgrade to 3.2.CR2

* Fri May 19 2006 Fernando Nasser <fnasser@redhat.com> - 0:3.1-1jpp_1rh
- Merge with upstream for upgrade

* Tue May 02 2006 Ralph Apel <r.apel@r-apel.de> - 0:3.1-1jpp
- Upgrade to 3.1

* Sat Feb 25 2006 Fernando Nasser <fnasser@redhat.com> - 0:3.0-2jpp_1rh
- First Red Hat build

* Fri Feb 24 2006 Fernando Nasser <fnasser@redhat.com> - 0:3.0-2jpp
- First JPP 1.7 build

* Fri Mar 04 2005 Ralph Apel <r.apel at r-apel.de> - 0:3.0-1jpp
- Upgrade to 3.0 final
- Fixed _docdir ownership

* Sun Aug 22 2004 Randy Watler <rwatler at finali.com> - 0:3.0-0.beta.2jpp
- Rebuild with ant-1.6.2

* Fri Jun 04 2004 Ralph Apel <r.apel at r-apel.de> - 0:3.0-0.beta.1jpp
- preview of 3.0

* Fri Mar 05 2004 Ralph Apel <r.apel at r-apel.de> - 0:2.6-1jpp
- First JPackage release
